/*
pbwget.c SAW 16-Jan-95
Based on emuget

A process to connect to pburelay and write the messages to
stdout.

*/

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <iostream>
#include "tcp.h"

#define DEFAULT_SERVER_NODE "localhost"
#define MAX_MESSAGE_LENGTH 8192

static char *ServerNode=0;
static int fd;

using namespace std;

int main(int argc, char **argv)
{
int arg, rc;
unsigned Length;
char Message[MAX_MESSAGE_LENGTH+1];

/* Set defaults and read in parameters from command line */

   ServerNode = (char *)malloc( strlen( DEFAULT_SERVER_NODE ) + 1 );
   if ( !ServerNode ) exit(0);
   strcpy( ServerNode, DEFAULT_SERVER_NODE );
   
   for ( arg=1;arg<argc;arg++ )
   {
      if ( !strcmp( argv[arg], "-server" ) )
      {
         ServerNode = (char *)realloc( ServerNode, strlen( argv[arg+1] ) + 1 );
         if ( !ServerNode ) exit(0);
         strcpy( ServerNode, argv[arg+1] );
         arg++;
      }
      else
         arg++;
   }

   for ( ;;sleep(60) )
   {

      for( ;;sleep(60) )
      {

/* Make connection to pbwrelay */

         fd = open_tcp_service( ServerNode, "pbwrly" );
         if ( fd < 0 )
         {
            fd = open_tcp_service( ServerNode, "7999" );
            if ( fd < 0 ) { cerr<<"Failed to connect. Retry in 60s."<<endl; continue; }
         }

         sockstream S = fd;

         // unsigned pid = getpid();
         // S << pid;

/* Loop forever, reading messages and writing to stdout */

         for (;;)
         {
            try
	    {
	      S.rcv(Message,4);
              Length = *reinterpret_cast<unsigned *>(Message);
              S.rcv( Message, Length-4 );
	    }
	    catch (ss_exception &sse)
	    {
	      cerr<<sse.what()<<" errcode="<<sse.errcode()<<endl;
              break;
	    }

            rc = write(1, Message, 4 );
            rc = write(1, Message, Length );
            if ( rc == EOF ) { fprintf(stderr,"Error %d writing message\n",errno); break; }
            fflush( stdout );
         }
         if ( rc == EOF ) break;
      }
      if ( fd != EOF ) close( fd );
   }
   exit(0);
}

