#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

/*
Receive message.

Returns size of received message or
        -1 on error and error code stored in errno
        -3 otherwise

*/

int msg_rcv( int fd, void *buf, int size )
{
int len, rcvd, cc;
void *msgbuf;

/* Read the length */

   for( rcvd=0; rcvd<4; rcvd+=cc )
   {
      errno = 0;

      cc = read( fd, (char*)&len + rcvd, 4 - rcvd );

      if ( cc == 0 ) return -3; /* EOF (i.e. socket closed) condition */

      if ( cc < 0 )
      {
         if ( errno == EAGAIN && !rcvd ) return 0;
         else if ( errno == EINTR || errno == EAGAIN ) cc = 0;
         else return -1;
      }
   }

/* Check the buffer is large enough or create one if needed */

   if ( len > size ) return -3;

   size = len;
   
/* Read the message buffer contents */

   for( rcvd=0; rcvd<len; rcvd+=cc )
   {
      errno = 0;

      cc = read( fd, (char*)buf + rcvd, len - rcvd );

      if ( cc == 0 ) return -3; /* EOF (i.e. socket closed) condition */
      
      if ( cc < 0 )
      {
         if ( errno == EINTR || errno == EAGAIN ) cc = 0;
         else return -1;
      }
   }
   
   return size;
}

