#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int msg_send( int fd, const void *buf, int len )
{
int sent, cc;

/* Send the length */

   for ( sent=0;sent<4;sent+=cc )
   {
      errno = 0;
      cc = write( fd, (char *)&len + sent, 4 - sent );
      if( cc == -1 )
      {
         if( errno != EINTR ) return -1;
         cc = 0;
      }
   }

/* Now send the message buffer contents */

   for ( sent=0;sent<len;sent+=cc )
   {
      errno = 0;
      cc = write( fd, (char *)buf + sent, len - sent );
      if( cc == -1 )
      {
         if( errno != EINTR ) return -1;
         cc = 0;
      }
   }
   
   return 0;
}

