#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include "libtcp.h"

int msg_send( int fd, void *buf, int len )
{
int sent, cc, packets, remainder;
unsigned char clen[4];

/* Encode the length big-endian to make machine independent */

   clen[3] = len & 0xff;
   clen[2] = (len>>8) & 0xff;
   clen[1] = (len>>16) & 0xff;
   clen[0] = (len>>24) & 0xff;

/* Send the length */

   for ( sent=0;sent<4;sent+=cc )
   {
      errno = 0;
      cc = write( fd, (char *)clen + sent, 4 - sent );
      if( cc == -1 )
      {
         if( errno != EINTR ) return -1;
         cc = 0;
      }
   }

/* Now send the message buffer contents */

   remainder = len % MAX_XMIT_SIZE;
   packets = (len - remainder) / MAX_XMIT_SIZE + 1;
   
   for ( ;packets;packets-- )
   {
      if ( packets == 1 ) len = remainder;
      else len = MAX_XMIT_SIZE;
      
      for ( sent=0;sent<len;sent+=cc )
      {
         errno = 0;
         cc = write( fd, (char *)buf + sent, len - sent );
         if( cc == -1 )
         {
            if( errno != EINTR ) return -1;
            cc = 0;
         }
      }
      buf = (char *)buf + MAX_XMIT_SIZE;
   }
   
   return 0;
}

