/*

Implementation of sockstream class

*/

#include <string.h>
#include "tcp.h"
#include "parser.h"
extern int h_errno;

sockstream::sockstream( const char *server, const char *service )
{
char *Context=0;
char *srv, *list;

/* "service" is a list of service names to try. Each one is tried in turn first
assuming it is a service name (in /etc/services) then assuming it is an
environment variable containing a port number. This permits various failover
strategies to be tried. */

   list = new char[strlen(service)+1]; strcpy( list,service );

   for ( s=-1,srv=stoken(&Context,list,":,/ ");(s < 0) && srv;srv=stoken(&Context,0,":,/ ") )
   {
      s = open_tcp_service( server, srv );
      if ( (s < 0) &&  getenv(srv) ) s = open_tcp_service( server, getenv(srv) );
   }

   delete [] list;

   if ( s == -1 ) error = errno;
   else if ( s == -2 ) error = h_errno;
   else if ( s == -3 ) error = -1;
   else error = 0;

}
